#!/usr/bin/env python
# -*- coding: utf-8 -*-

from PySide import QtCore, QtGui

import dbus
import dbus.service

from sys import argv, exit

from pysrc import MainWindowExt
from pysrc import myconfig
from pysrc import pic_rc

from dbus.mainloop.glib import DBusGMainLoop
DBusGMainLoop(set_as_default=True)

if __name__ == "__main__":
	
	app = QtGui.QApplication( argv )
	
	pxm = QtGui.QPixmap(":/splash/pictures/splash.png")
	splash = QtGui.QSplashScreen(pxm)
	splash.show()
	app.processEvents()

	trans = QtCore.QTranslator()

	lcl = QtCore.QLocale()
	
	if lcl.language() == QtCore.QLocale.Russian:
		trans.load( myconfig.i18n_rus )
		app.installTranslator( trans )
	
	ui = MainWindowExt.MainWindowExt( splash )

	ui.show()

	#splash.finish(ui)

	exit(app.exec_())
